commit ca97ea7aa2cb7186f432aaba76f4f151aa90c1d0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Oct 15 20:20:22 2015 -0300

    [ft] Revert change-of-behavior of hb_ft_font_create() introduced
    in 1.0.5

    The default FreeType load flags where changed from FT_LOAD_NO_HINTING
    to FT_LOAD_DEFAULT in 2a9627c5641cd000e2adff0e42a0dc687b53ec70.
    This is crashing HarfBuzz-enabled FreeType as I suppose it causes
    infinite recursion between HB and FT autohinter...

    Revert the behavior change.

    Fixes https://github.com/behdad/harfbuzz/issues/143

 src/hb-ft.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 338ffec9e4a5819f2be21c3a320a567378c977b1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Oct 15 12:55:57 2015 -0300

    Add tests for a couple of fixed issues found by libFuzzer

    From:
    https://github.com/behdad/harfbuzz/issues/139#issuecomment-147616887
    https://github.com/behdad/harfbuzz/issues/139#issuecomment-148289957

 .../sha1sum/375d6ae32a3cbe52fbf81a4e5777e3377675d5a3.ttf | Bin 0 ->
 1024 bytes
 .../sha1sum/641bd9db850193064d17575053ae2bf8ec149ddc.ttf | Bin 0 ->
 305 bytes
 test/shaping/fonts/sha1sum/MANIFEST                      |   2 ++
 test/shaping/tests/fuzzed.tests                          |   2 ++
 4 files changed, 4 insertions(+)

commit 63ef0b41dc48d6112d1918c1b1de9de8ea90adb5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Oct 15 12:47:22 2015 -0300

    [ot-font] Fix hmtx wrong table length check

    Discovered by libFuzzer.  Ouch!

    https://github.com/behdad/harfbuzz/issues/139#issuecomment-148289957

 src/hb-ot-font.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 613e630617074eb9b62b794cc37c9b42a7fb079b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Oct 13 23:33:28 2015 -0300

    Reduce max nesting level from 8 to 6

    We probably should implement better system to catch cyclic lookups.
    But for now, this speeds up worst case behavior with broken fonts
    considerably without compromising legitimate usecases.

    https://github.com/behdad/harfbuzz/issues/139#issuecomment-147788447

 src/hb-ot-layout-common-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ab170529246ad80830bef2b3c8b48e9a8d2b7483
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Oct 13 10:55:33 2015 -0300

    1.0.5

 NEWS         | 24 ++++++++++++++++++++++++
 configure.ac |  2 +-
 2 files changed, 25 insertions(+), 1 deletion(-)

commit ed13e2ce509408f849255be1d3cc3dbd7dbb3ba2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Oct 13 10:32:56 2015 -0300

    [ot-font] Fix leak

    https://github.com/behdad/harfbuzz/issues/139#issuecomment-147616887

 src/hb-ot-font.cc | 1 +
 1 file changed, 1 insertion(+)

commit 55db94be2b754ba9b9121f09abcf8496c798affc
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Oct 13 00:33:59 2015 -0400

    Add test for previous commit

 .../sha1sum/0509e80afb379d16560e9e47bdd7d888bebdebc6.ttf   | Bin 0 ->
 61 bytes
 test/shaping/fonts/sha1sum/MANIFEST                        |   1 +
 test/shaping/tests/fuzzed.tests                            |   1 +
 3 files changed, 2 insertions(+)

commit f96664974774bfeb237a7274f512f64aaafb201e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Oct 13 00:30:50 2015 -0400

    Fix another memory access issue discovered by libFuzzer

    Fixes
    https://github.com/behdad/harfbuzz/issues/139#issuecomment-146984679

 src/hb-ot-layout-gpos-table.hh | 4 +++-
 1 file changed, 3 insertions(+), 1 deletion(-)

commit c1a5dc46c2231f7b62421e06b9766ccfebaf3ef5
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Oct 12 17:39:52 2015 -0400

    [fuzz] Add fuzzing script from kcc@

    https://github.com/behdad/harfbuzz/issues/139

 test/fuzzing/hb-fuzzer.cc | 47
 +++++++++++++++++++++++++++++++++++++++++++++++
 1 file changed, 47 insertions(+)

commit cc6ea308d4c99b9dd6d625fa3a9b0ef62fa2614f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Oct 12 17:21:52 2015 -0400

    Extern "C" custom-allocator declerations

 src/hb-private.hh | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 98c6fccc00062ead7a86892dd059aa13d266b981
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Oct 11 21:41:04 2015 -0400

    Add test for ee9b0b6cb5fdb08671ab064f26c299135f828260

 .../sha1sum/5a5daf5eb5a4db77a2baa3ad9c7a6ed6e0655fa8.ttf   | Bin 0 ->
 61 bytes
 test/shaping/fonts/sha1sum/MANIFEST                        |   1 +
 test/shaping/tests/fuzzed.tests                            |   1 +
 3 files changed, 2 insertions(+)

commit 50f489a0a013fc589626bb532a9f64f50bb41f58
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Oct 11 20:59:29 2015 -0400

    Typo

 src/hb-font-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit ee9b0b6cb5fdb08671ab064f26c299135f828260
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Oct 9 14:23:15 2015 -0400

    Fix another sanitize bug

    Also discovered by "libFuzzer".

 src/hb-open-type-private.hh | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 34379b49e6922b86c15ee62f7fe3bf016cdc2514
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Oct 9 12:34:02 2015 -0400

    Add test for previous fix

 test/shaping/Makefile.am                                   |   1 +
 .../sha1sum/1a6f1687b7a221f9f2c834b0b360d3c8463b6daf.ttf   | Bin 0 ->
 64 bytes
 test/shaping/fonts/sha1sum/MANIFEST                        |   1 +
 test/shaping/tests/MANIFEST                                |   1 +
 test/shaping/tests/fuzzed.tests                            |   1 +
 5 files changed, 4 insertions(+)

commit f396fbb000dc1c8acddbf6a16e193b328c5e551e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Oct 9 12:25:55 2015 -0400

    Fix return value of sanitize when subformat is not readable

    This is a fix on top of the previous issue fixed in
    c917965b9e6fe2b21ed6c51559673288fa3af4b7.

    This was caught by "libFuzzer" testing.

 src/hb-open-type-private.hh          |  2 ++
 src/hb-ot-layout-gpos-table.hh       | 15 +++++++--------
 src/hb-ot-layout-gsub-table.hh       | 13 ++++++-------
 src/hb-ot-layout-gsubgpos-private.hh |  8 ++++----
 4 files changed, 19 insertions(+), 19 deletions(-)

commit 77a1a2bc18e7b04d4e352a8777ccce345b2f8659
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Oct 9 12:20:58 2015 -0400

    Add hb_dispatch_context_t

 src/hb-open-type-private.hh          | 26 ++++++++++++++++++++++----
 src/hb-ot-layout-gsubgpos-private.hh | 36
 ++++++++++++------------------------
 src/hb-ot-layout.cc                  |  8 +++-----
 3 files changed, 37 insertions(+), 33 deletions(-)

commit 3e905e396bcd745bda88e751998a76556c5cb8c6
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Oct 8 12:51:02 2015 -0400

    Add hb_font_set_parent()

    No reason to not have it.  Makes life easier later.
    We (hb-ft, hb-ot-font, etc) can use this API to inject new
    parent into a font...

 src/hb-font.cc       | 26 ++++++++++++++++++++++++++
 src/hb-font.h        |  4 ++++
 test/api/test-font.c | 12 ++++++++++++
 3 files changed, 42 insertions(+)

commit edeb3dabf4a589d67c3f1da7ba43a74e4d3a9afd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Oct 8 12:47:15 2015 -0400

    [ft] Add version for new API

 src/hb-ft.cc | 18 ++++++++++++++++++
 1 file changed, 18 insertions(+)

commit 2a9627c5641cd000e2adff0e42a0dc687b53ec70
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Oct 7 17:33:20 2015 -0400

    [ft] API: Add hb_font_[sg]et_load_flags() API

    This changes the default load_flags of fonts created using
    hb_ft_font_create() from NO_HINTING to DEFAULT.  Hope that doesn't
    break too much client code.

    Code calling hb_ft_font_set_funcs() is unaffected.

 src/hb-ft.cc | 163
 +++++++++++++++++++++++++++++++++++++++--------------------
 src/hb-ft.h  |  13 +++--
 2 files changed, 118 insertions(+), 58 deletions(-)

commit 3224a594dcf2164b5585b4ccba34f244af3f61b9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Oct 7 17:33:02 2015 -0400

    Minor

 src/hb-ot-font.cc | 5 ++---
 1 file changed, 2 insertions(+), 3 deletions(-)

commit 52b418555b62a3b25399f202c1fa72ab7288c224
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sat Oct 3 13:20:55 2015 +0100

    Allow compiling with custom allocators

    User can define hb_malloc_impl, etc, to name of custom allocator
    functions
    that have the same signature as malloc.

 src/hb-private.hh | 17 +++++++++++++++++
 1 file changed, 17 insertions(+)

commit 88da7bba9fa4665b33f5bfcd45add7443097eaf3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Oct 2 14:38:20 2015 +0100

    Default font scale to face upem

    Makes for a better default and avoids nasty inheritance issues.
    See mailing list thread "Default hb_font_t scale".

 src/hb-font.cc       |  2 ++
 test/api/test-font.c | 13 ++++++++-----
 2 files changed, 10 insertions(+), 5 deletions(-)

commit 1866e17114b41d565eb066e7d9393c2ff3e0a12b
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Oct 2 14:21:29 2015 +0100

    Make hb_font_create_sub_font() NOT make parent immutable

    We don't rely on that.  However, whenever hb_font_make_immutable()
    is called, it makes its parenting chain immutable.

 src/hb-font.cc       |  4 +++-
 test/api/test-font.c | 21 +++++++++++++++------
 2 files changed, 18 insertions(+), 7 deletions(-)

commit 980e25cad2e58c31f5361862b9223d94ec47fc7a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Oct 2 08:21:12 2015 +0100

    Fix hb-ot-shape-normalize with empty buffer

    Part of https://github.com/behdad/harfbuzz/issues/136

 src/hb-ot-shape-normalize.cc | 2 ++
 1 file changed, 2 insertions(+)

commit a5efaac4ff61b587f228830b265b39fe8e5e4e47
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Oct 2 08:02:29 2015 +0100

    Replace a couple of malloc()s with calloc()

 src/hb-face.cc       | 2 +-
 src/hb-shape-plan.cc | 2 +-
 src/hb-shaper.cc     | 2 +-
 3 files changed, 3 insertions(+), 3 deletions(-)

commit 26ba4d1e1fb8949632fe08e6a7600badfba4f142
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Oct 2 07:25:52 2015 +0100

    Fix segfault with empty buffer in hb_shape_plan_execute()

    Move the empty-buffer check from hb_shape_full() to
    hb_shape_plan_execute().

    Reported by Simon Cozens.

 src/hb-shape-plan.cc | 9 +++++++--
 src/hb-shape.cc      | 5 -----
 2 files changed, 7 insertions(+), 7 deletions(-)

commit 432ffc47a46d41bea17d839d0d3980e654c6e638
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Sep 30 22:51:16 2015 +0100

    1.0.4

 NEWS         | 7 +++++++
 configure.ac | 2 +-
 2 files changed, 8 insertions(+), 1 deletion(-)

commit b47159011ca518c3b94d782ed16a91ffe9dd2ab2
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 29 14:57:02 2015 +0100

    Define return_trace()

    Not functional change (expected!).

 src/hb-open-file-private.hh          |  20 +--
 src/hb-open-type-private.hh          |  62 +++----
 src/hb-ot-cmap-table.hh              |  56 +++----
 src/hb-ot-glyf-table.hh              |   4 +-
 src/hb-ot-head-table.hh              |   2 +-
 src/hb-ot-hhea-table.hh              |   2 +-
 src/hb-ot-hmtx-table.hh              |   2 +-
 src/hb-ot-layout-common-private.hh   | 108 ++++++-------
 src/hb-ot-layout-gdef-table.hh       |  44 ++---
 src/hb-ot-layout-gpos-table.hh       | 252 +++++++++++++++--------------
 src/hb-ot-layout-gsub-table.hh       | 304
 ++++++++++++++++++-----------------
 src/hb-ot-layout-gsubgpos-private.hh | 205 +++++++++++------------
 src/hb-ot-layout-jstf-table.hh       |  35 ++--
 src/hb-ot-maxp-table.hh              |   5 +-
 src/hb-ot-name-table.hh              |  14 +-
 src/hb-private.hh                    |   6 +-
 16 files changed, 575 insertions(+), 546 deletions(-)

commit c917965b9e6fe2b21ed6c51559673288fa3af4b7
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 29 14:45:35 2015 +0100

    Add missing returns

    Fixes possible invalid read of two bytes.

    Reported by Behzad Najjarpour Jabbari, Secunia Research.

 src/hb-ot-layout-gpos-table.hh       | 14 +++++++-------
 src/hb-ot-layout-gsub-table.hh       | 12 ++++++------
 src/hb-ot-layout-gsubgpos-private.hh |  8 ++++----
 3 files changed, 17 insertions(+), 17 deletions(-)

commit f3159ba5141c2ab0e430e64742972df140f91c43
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 29 14:34:56 2015 +0100

    Micro-optimize hb_language_from_string()

    As measured / improved by Benson Limketkai.

 src/hb-common.cc | 10 +++++-----
 1 file changed, 5 insertions(+), 5 deletions(-)

commit f2ad935e19338a29113492150f0c5a5fd5befd75
Author: Sascha Brawer <sascha@brawer.ch>
Date:   Sun Jun 28 03:29:47 2015 +0200

    Handle language tags that indicate phonetic IPA transcription

    The BCP-47 registry defines a variant subtag "fonipa" that can be used
    in combination with arbitrary other language tags. For example,
    "rm-CH-fonipa-sursilv" indicates the Sursilvan dialect of Romansh
    as used in Switzerland, transcribed used the International Phonetic
    Alphabet.

    http://www.iana.org/assignments/language-subtag-registry/language-subtag-registry

 src/hb-ot-tag.cc       | 15 ++++++++++++++-
 test/api/test-ot-tag.c |  7 +++++++
 2 files changed, 21 insertions(+), 1 deletion(-)

commit b8811429b6810c4f13be087b593a862c17d9d987
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Sep 3 15:53:22 2015 +0430

    Fix Since tags

    Fixes https://github.com/behdad/harfbuzz/issues/103

 src/hb-blob.cc             | 24 +++++++++----------
 src/hb-buffer-serialize.cc | 10 ++++----
 src/hb-buffer.cc           | 58
 +++++++++++++++++++++++-----------------------
 src/hb-buffer.h            |  9 +++++++
 src/hb-common.cc           | 24 +++++++++----------
 src/hb-common.h            |  3 +++
 src/hb-coretext.cc         |  3 +++
 src/hb-font.h              | 18 +++++++-------
 src/hb-ft.cc               |  6 ++---
 src/hb-graphite2.cc        |  6 +++++
 src/hb-ot-layout.cc        |  2 +-
 src/hb-ot-tag.cc           |  2 +-
 src/hb-set.h               |  3 +++
 src/hb-shape.cc            |  2 +-
 src/hb-unicode.cc          | 18 +++++++-------
 src/hb-unicode.h           | 10 ++++----
 16 files changed, 111 insertions(+), 87 deletions(-)

commit 5d74ff02ab01df67808b416af8bb9cefb06f841e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Sep 3 14:55:59 2015 +0430

    Fix Since: version tags on font and face APIs

    A while back we marked every API as version:1.0.  We should fix
    them all
    to reflect real version they were introduced.  This is a start.

    Patch from Nikolay Sivov.

 src/hb-face.cc | 22 ++++++++---------
 src/hb-font.cc | 76
 +++++++++++++++++++++++++++++-----------------------------
 2 files changed, 49 insertions(+), 49 deletions(-)

commit 7f5405397406a24c5a001b5ef43dcf4d6926415e
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 1 17:03:50 2015 +0100

    1.0.3

 NEWS         | 11 +++++++++++
 configure.ac |  2 +-
 2 files changed, 12 insertions(+), 1 deletion(-)

commit 5828c45d7a816ccd0a7f10a665ea3cf8cfd63b05
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 1 16:26:35 2015 +0100

    [indic] Add comments to merge_clusters calls

 src/hb-ot-shape-complex-indic.cc | 21 ++++++++++++++++-----
 1 file changed, 16 insertions(+), 5 deletions(-)

commit bdc8215949a7add742cc800b4fdea6acaa37d152
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 1 16:24:54 2015 +0100

    [thai] Respect cluster-level > 0

 src/hb-ot-shape-complex-thai.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit 5b31fe383ead726ec77062501ed3bb24c02842b3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 1 16:24:34 2015 +0100

    [use] Merge /before/ reordering

 src/hb-ot-shape-complex-use.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit 0d438f89bd9422c66838c776eb4aa867de0a2ad8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 1 16:24:13 2015 +0100

    [hangul] Merge /before/ reordering

 src/hb-ot-shape-complex-hangul.cc | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit f883de664fc4bfe01e30c89e07e31dc113f906d9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 1 16:23:40 2015 +0100

    [OT] Merge /before/ reordering

 src/hb-ot-shape.cc | 5 +++--
 1 file changed, 3 insertions(+), 2 deletions(-)

commit c403d6320074455a5e8e48902c0ac4ee9685e33d
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 1 16:15:25 2015 +0100

    [myanmar] Use buffer->sort() to sort cluster

    This can possibly produce more granular clusters.

 src/hb-ot-shape-complex-myanmar.cc | 3 +--
 1 file changed, 1 insertion(+), 2 deletions(-)

commit e995d33c10a4bd9404699d01bddb2b69d811e9ed
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 1 16:13:32 2015 +0100

    [OT] Merge clusters when reordering marks for normalization

    Fixes https://bugzilla.gnome.org/show_bug.cgi?id=541608
    and cluster test.

 src/hb-buffer-private.hh     |  2 ++
 src/hb-buffer.cc             | 21 +++++++++++++++++++++
 src/hb-ot-shape-normalize.cc |  2 +-
 3 files changed, 24 insertions(+), 1 deletion(-)

commit b6d7d161a87b5dde710924e5c557d39c302f5630
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 1 16:12:44 2015 +0100

    [tests] Add Hebrew test for normalization under cluster-level=1

    Currently fails.
    https://bugzilla.gnome.org/show_bug.cgi?id=541608

 .../sha1sum/43ef465752be9af900745f72fe29cb853a1401a5.ttf | Bin 0 ->
 4272 bytes
 test/shaping/fonts/sha1sum/MANIFEST                      |   1 +
 test/shaping/tests/cluster.tests                         |   1 +
 3 files changed, 2 insertions(+)

commit 93099748e39740a3f6f003c83d9dec1d21660ce8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 1 16:11:27 2015 +0100

    Minor

 src/hb-private.hh | 6 ++----
 1 file changed, 2 insertions(+), 4 deletions(-)

commit 85846b3de7491b6a07fed6a2c0c6c1b09943b249
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 1 15:07:52 2015 +0100

    Use insertion-sort instead of bubble-sort

    Needed for upcoming merge-clusters fix.

 src/hb-buffer.cc                           |  4 +--
 src/hb-ot-shape-complex-arabic-fallback.hh |  6 ++--
 src/hb-ot-shape-complex-indic.cc           |  2 +-
 src/hb-ot-shape-complex-myanmar.cc         |  2 +-
 src/hb-ot-shape-normalize.cc               |  6 ++--
 src/hb-private.hh                          | 56
 +++++++++++++-----------------
 6 files changed, 34 insertions(+), 42 deletions(-)

commit fad2674874591b4a1df822603144c8864f5364c1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Sep 1 14:45:46 2015 +0100

    Minor

 test/Makefile.am         | 4 ++++
 test/api/Makefile.am     | 4 ++++
 test/shaping/Makefile.am | 4 ++++
 3 files changed, 12 insertions(+)

commit 23e4fac6de913201f263a73e13d3c1fab31d1bdd
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 31 19:41:01 2015 +0100

    Update git.mk from upstream

 git.mk | 17 ++++++++++++++++-
 1 file changed, 16 insertions(+), 1 deletion(-)

commit 5783e05f81bbf6debf2618c8994d6852630d9847
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 31 19:18:10 2015 +0100

    [docs] Move docs/reference/ contents into docs/

 configure.ac                          |   3 +-
 docs/Makefile.am                      | 117 +++++++-
 docs/harfbuzz-docs.xml                |  78 ++++++
 docs/harfbuzz-overrides.txt           |   0
 docs/harfbuzz-sections.txt            | 498
 ++++++++++++++++++++++++++++++++++
 docs/reference/Makefile.am            | 118 --------
 docs/reference/harfbuzz-docs.xml      |  78 ------
 docs/reference/harfbuzz-overrides.txt |   0
 docs/reference/harfbuzz-sections.txt  | 498
 ----------------------------------
 docs/reference/usermanual-ch01.xml    | 115 --------
 docs/reference/usermanual-ch02.xml    | 183 -------------
 docs/reference/usermanual-ch03.xml    |  77 ------
 docs/reference/usermanual-ch04.xml    |  18 --
 docs/reference/usermanual-ch05.xml    |  13 -
 docs/reference/usermanual-ch06.xml    |   8 -
 docs/reference/version.xml.in         |   1 -
 docs/usermanual-ch01.xml              | 115 ++++++++
 docs/usermanual-ch02.xml              | 183 +++++++++++++
 docs/usermanual-ch03.xml              |  77 ++++++
 docs/usermanual-ch04.xml              |  18 ++
 docs/usermanual-ch05.xml              |  13 +
 docs/usermanual-ch06.xml              |   8 +
 docs/version.xml.in                   |   1 +
 23 files changed, 1108 insertions(+), 1112 deletions(-)

commit cd5e3a13a6e0b6606d3a421f8cd44cdfb8314907
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 31 19:16:41 2015 +0100

    [docs] Fix out-of-tree build

 docs/reference/Makefile.am         |   9 +-
 docs/reference/harfbuzz-docs.xml   |  12 +--
 docs/reference/usermanual-ch01.xml | 115 +++++++++++++++++++++++
 docs/reference/usermanual-ch02.xml | 183
 +++++++++++++++++++++++++++++++++++++
 docs/reference/usermanual-ch03.xml |  77 ++++++++++++++++
 docs/reference/usermanual-ch04.xml |  18 ++++
 docs/reference/usermanual-ch05.xml |  13 +++
 docs/reference/usermanual-ch06.xml |   8 ++
 docs/usermanual-ch01.xml           | 115 -----------------------
 docs/usermanual-ch02.xml           | 183
 -------------------------------------
 docs/usermanual-ch03.xml           |  77 ----------------
 docs/usermanual-ch04.xml           |  18 ----
 docs/usermanual-ch05.xml           |  13 ---
 docs/usermanual-ch06.xml           |   8 --
 14 files changed, 428 insertions(+), 421 deletions(-)

commit 3899795fa3c3e058e3885ec7a6638f0597a752cc
Merge: d205965 01e16e8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 31 10:46:01 2015 +0100

    Merge pull request #131 from simoncozens/docs

    Use gtk-doc to build user's manual as well as reference

commit 01e16e88f50b65b82dcb84773f532f18a351319f
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Mon Aug 31 10:40:17 2015 +0100

    Combine user / reference information into gtk-doc generated manual.

 docs/reference/harfbuzz-docs.xml | 91
 +++++++++++++++++++++++-----------------
 1 file changed, 52 insertions(+), 39 deletions(-)

commit 11a07c4729174e1d4af028103ecb0a351e4c2707
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Mon Aug 31 10:39:10 2015 +0100

    Correct tag hierarchy, to allow for table-of-contents entries.

 docs/usermanual-ch01.xml | 12 ++++++------
 docs/usermanual-ch02.xml |  8 ++++----
 docs/usermanual-ch03.xml | 24 ++++++++++++------------
 docs/usermanual-ch04.xml | 16 ++++++++--------
 docs/usermanual-ch05.xml | 12 ++++++------
 5 files changed, 36 insertions(+), 36 deletions(-)

commit 387d6af428ddd5d4f211fe5748412011013a3826
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Mon Aug 31 10:31:09 2015 +0100

    Missing tag (oops).

 docs/usermanual-ch02.xml | 1 +
 1 file changed, 1 insertion(+)

commit d205965286798af4b7ad07e1eafa58288bee4bdb
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 31 10:12:05 2015 +0100

    [docs] Fix typo

 docs/usermanual-ch03.xml | 2 +-
 1 file changed, 1 insertion(+), 1 deletion(-)

commit c424b41705b50055c7f92b268cf78a2680af73af
Merge: 31594b9 5470e74
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 31 09:53:16 2015 +0100

    Merge pull request #129 from simoncozens/docs

    First two chapters. More to follow.

commit 31594b98af0c9181982c77d8d3803753007f8fd4
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Aug 30 17:33:04 2015 +0100

    [test] Fix test-object

    See previous commit.

 test/api/test-object.c | 4 ----
 1 file changed, 4 deletions(-)

commit 326b5ebf5748f547e4eb7388d66b79fe23130e2a
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Aug 30 17:29:21 2015 +0100

    Poison freed objects such that double-free is detected

    Previously we were setting refcount of freed objects to the inert
    value, which
    was harmful because it caused further destroy()s of the freed object
    to NOT
    call free() and hence hide the bug.  Indeed, after eb0bf3ae6688b7
    test-object
    was double-free'ing objects and this was never caught on Linux.
    It only was
    caught as crashing on Mac.

    Now we poison refcount upon freeing and check that it's valid
    whenever reading
    it.  Makes test-object fail now.

 src/hb-object-private.hh | 21 ++++++++++++++++-----
 1 file changed, 16 insertions(+), 5 deletions(-)

commit 5470e744dd264c2dc33437a68d20bcf7c5ffb905
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Sat Aug 29 08:21:18 2015 +0100

    Current state and skeleton outline

 docs/usermanual-ch03.xml | 77
 ++++++++++++++++++++++++++++++++++++++++++++++++
 docs/usermanual-ch04.xml | 18 +++++++++++
 docs/usermanual-ch05.xml | 13 ++++++++
 docs/usermanual-ch06.xml |  8 +++++
 4 files changed, 116 insertions(+)

commit 6578575cc8aeb05341f2053039acfcd735707674
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Aug 25 20:24:59 2015 +0100

    [GPOS] Fix cursive connection with mix of RTL and non-RTL lookups

    See thread "Issue with cursive attachment" started by Khaled.
    Turned out fixing this wasn't as bad as I had assumed.  I like the
    new code better; we now have a theoretical model of cursive
    connections that is easier to reason about.

 src/hb-ot-layout-gpos-table.hh | 34 ++++++++++++++++++++++++++++++++++
 1 file changed, 34 insertions(+)

commit 7368da67244ea53195cd9b95a5c57485df695732
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Aug 25 20:28:39 2015 +0100

    [test] Add test for cursive-positioning with mixed directions

    Fails now.  Fix coming.  See thread "Issue with cursive attachment"
    started by Khaled.  Test fonts were made by modifying test font
    from Khaled to add more anchors.

 test/shaping/Makefile.am                                 |   1 +
 .../sha1sum/298c9e1d955f10f6f72c6915c3c6ff9bf9695cec.ttf | Bin 0 ->
 2520 bytes
 test/shaping/fonts/sha1sum/MANIFEST                      |   2 ++
 .../sha1sum/c4e48b0886ef460f532fb49f00047ec92c432ec0.ttf | Bin 0 ->
 2512 bytes
 test/shaping/tests/MANIFEST                              |   1 +
 test/shaping/tests/cursive-positioning.tests             |   2 ++
 6 files changed, 6 insertions(+)

commit f0807654da160bd7ceb9aff5b8338ec0b643171c
Author: Simon Cozens <simon@simon-cozens.org>
Date:   Tue Aug 25 19:57:15 2015 +0100

    First two chapters. More to follow.

 docs/usermanual-ch01.xml | 115 ++++++++++++++++++++++++++++++
 docs/usermanual-ch02.xml | 182
 +++++++++++++++++++++++++++++++++++++++++++++++
 2 files changed, 297 insertions(+)

commit 58f2a73fb95af42e264a91cdef7bb5a89e965601
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Aug 25 18:55:34 2015 +0100

    [GPOS] Rewrite cursive attachment slightly differently

    In anticipation for upcoming fix for bug reported by
    Khaled in thread "Issue with cursive attachment".

 src/hb-ot-layout-gpos-table.hh | 36 ++++++++++++++++++++++++------------
 1 file changed, 24 insertions(+), 12 deletions(-)

commit fdd1770e006ca2d2973c049177ceda87a575e07f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 24 13:49:55 2015 +0100

    Add API/cmdline to show glyph extents when serializing buffer

    New API: HB_BUFFER_SERIALIZE_FLAG_GLYPH_EXTENTS

    hb-shape now accepts --show-extents.

    Patch from Simon Cozens.

 src/hb-buffer-serialize.cc | 17 +++++++++++++++++
 src/hb-buffer.h            |  3 ++-
 util/hb-shape.cc           |  2 ++
 util/options.cc            |  1 +
 util/options.hh            |  2 ++
 5 files changed, 24 insertions(+), 1 deletion(-)

commit 2cee5b68a07b99214ef9428fe5d03e7b378a558f
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Mon Aug 24 13:45:12 2015 +0100

    [ot-font] Fix short-offset calculation

 src/hb-ot-font.cc | 4 ++--
 1 file changed, 2 insertions(+), 2 deletions(-)

commit b50fcfa82994f93568a54dd1eb7fd327f6db5586
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Sun Aug 23 14:42:20 2015 +0100

    [ot-font] Implement glyph_extents() for TrueType fonts

    This brings ot-fonts into almost-complete shape and mostly in par with
    ft font.

 src/Makefile.am         |   1 +
 src/hb-font.h           |   9 +++--
 src/hb-ot-font.cc       |  90 +++++++++++++++++++++++++++++++++++++++--
 src/hb-ot-glyf-table.hh | 104
 ++++++++++++++++++++++++++++++++++++++++++++++++
 src/hb-ot-head-table.hh |   3 +-
 5 files changed, 198 insertions(+), 9 deletions(-)

commit 0299b45000b5047c0b9bf0fe51f3b8b68a7982f8
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Fri Aug 21 12:44:36 2015 +0100

    Make BYTE a real type

 src/hb-open-type-private.hh | 16 +++++++++++++++-
 1 file changed, 15 insertions(+), 1 deletion(-)

commit ed6962c795ae7c54aaee9ed5667fa65ccf7412bf
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Aug 20 15:39:53 2015 +0100

    [coretext] Use i32 instead of u32 as well

    Shouldn't cause *any* functional changes, but is more correct.

 src/hb-coretext.cc | 20 ++++++++++----------
 1 file changed, 10 insertions(+), 10 deletions(-)

commit 163c435f1807c138da9f74f09d29d913eb9e29e9
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Thu Aug 20 15:39:06 2015 +0100

    [uniscribe] Fix negative offsets

    Ouch!

 src/hb-uniscribe.cc | 8 ++++----
 1 file changed, 4 insertions(+), 4 deletions(-)

commit 789b89ef7130ffe5f22c571fc3cb4e6d35456654
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Aug 19 13:39:57 2015 +0100

    1.0.2

 NEWS         | 13 +++++++++++++
 configure.ac |  2 +-
 2 files changed, 14 insertions(+), 1 deletion(-)

commit 958c268fa3a520666436e77a2111a3b564a36d96
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Aug 19 13:22:12 2015 +0100

    [coretext] Add TODO item

 src/hb-coretext.cc | 1 +
 1 file changed, 1 insertion(+)

commit 7c5bee09d9c7c25672c7c77572ebae0b731892d0
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Wed Aug 19 13:20:31 2015 +0100

    [uniscribe] Fix font scale handling

    By default shape at upem (or ppem), and scale results.
    Similar to work done in CoreText backend, but using upem as default.

 src/hb-uniscribe.cc | 25 +++++++++++++++++++------
 1 file changed, 19 insertions(+), 6 deletions(-)

commit 902e74a098dad8c3b487856284f9fdf99b04f9f1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Aug 18 18:55:03 2015 +0100

    Commented-out code to print buffer before each lookup

    To be turned into a useful HB_DEBUG_SHAPE infrastructure...

 src/hb-ot-layout.cc | 12 ++++++++++++
 1 file changed, 12 insertions(+)

commit 75504a50488a6aac0b9789f728fb5b87e641d4c3
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Aug 18 18:47:02 2015 +0100

    Allow serializing buffer with output-buffer being used

    Ie, don't call get_positions() if positions are not
    requested for serialization.

 src/hb-buffer-serialize.cc | 6 ++++--
 1 file changed, 4 insertions(+), 2 deletions(-)

commit e47b772a56af44a9a4f9ec907ee2091b725b94c1
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Aug 18 18:42:47 2015 +0100

    [ot] Change buffer content type right after we map to glyphs

    Needed for upcoming debug output changes.

 src/hb-ot-shape.cc | 2 ++
 1 file changed, 2 insertions(+)

commit d104415e4c1e0f9140f794cd8d09c6460c63e966
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Aug 18 17:33:34 2015 +0100

    [Android.mk] Update for SEA removal and USE addition

 Android.mk | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

commit ddd6bf12f1cabaa298feed820313483b9893528c
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Aug 18 15:55:09 2015 +0100

    Don't declare dependency on freetype in harfbuzz.pc

    See comments.

 src/Makefile.am | 7 ++++++-
 1 file changed, 6 insertions(+), 1 deletion(-)

commit 2c8b3b2e5312c9858584f568b1528c57e5bb8a10
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Aug 18 14:36:43 2015 +0100

    [debug] Print lookup index in debug-apply output

 src/hb-ot-layout-gpos-table.hh       | 5 ++++-
 src/hb-ot-layout-gsub-table.hh       | 5 ++++-
 src/hb-ot-layout-gsubgpos-private.hh | 7 +++++--
 src/hb-ot-layout.cc                  | 3 ++-
 4 files changed, 15 insertions(+), 5 deletions(-)

commit 50ad7788eeb7160caef4ec78e65c7c630e601b06
Author: Behdad Esfahbod <behdad@behdad.org>
Date:   Tue Aug 18 10:22:16 2015 +0100

    [coretext] Remove assert that kicks in on Mac OS 10.6

    http://crbug.com/419769

 src/hb-coretext.cc | 18 ++++++++++++++----
